// Auto-generated. Do not edit!

// (in-package clearpath_localization_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class GNSSStatus {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.receiver_type = null;
      this.position_fix_type = null;
      this.heading_fix_type = null;
      this.num_connected_sats = null;
      this.num_sats_solution = null;
      this.cn0 = null;
      this.correction_age = null;
    }
    else {
      if (initObj.hasOwnProperty('receiver_type')) {
        this.receiver_type = initObj.receiver_type
      }
      else {
        this.receiver_type = 0;
      }
      if (initObj.hasOwnProperty('position_fix_type')) {
        this.position_fix_type = initObj.position_fix_type
      }
      else {
        this.position_fix_type = 0;
      }
      if (initObj.hasOwnProperty('heading_fix_type')) {
        this.heading_fix_type = initObj.heading_fix_type
      }
      else {
        this.heading_fix_type = 0;
      }
      if (initObj.hasOwnProperty('num_connected_sats')) {
        this.num_connected_sats = initObj.num_connected_sats
      }
      else {
        this.num_connected_sats = 0;
      }
      if (initObj.hasOwnProperty('num_sats_solution')) {
        this.num_sats_solution = initObj.num_sats_solution
      }
      else {
        this.num_sats_solution = 0;
      }
      if (initObj.hasOwnProperty('cn0')) {
        this.cn0 = initObj.cn0
      }
      else {
        this.cn0 = [];
      }
      if (initObj.hasOwnProperty('correction_age')) {
        this.correction_age = initObj.correction_age
      }
      else {
        this.correction_age = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GNSSStatus
    // Serialize message field [receiver_type]
    bufferOffset = _serializer.uint8(obj.receiver_type, buffer, bufferOffset);
    // Serialize message field [position_fix_type]
    bufferOffset = _serializer.uint8(obj.position_fix_type, buffer, bufferOffset);
    // Serialize message field [heading_fix_type]
    bufferOffset = _serializer.uint8(obj.heading_fix_type, buffer, bufferOffset);
    // Serialize message field [num_connected_sats]
    bufferOffset = _serializer.uint8(obj.num_connected_sats, buffer, bufferOffset);
    // Serialize message field [num_sats_solution]
    bufferOffset = _serializer.uint8(obj.num_sats_solution, buffer, bufferOffset);
    // Serialize message field [cn0]
    bufferOffset = _arraySerializer.float32(obj.cn0, buffer, bufferOffset, null);
    // Serialize message field [correction_age]
    bufferOffset = _serializer.float64(obj.correction_age, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GNSSStatus
    let len;
    let data = new GNSSStatus(null);
    // Deserialize message field [receiver_type]
    data.receiver_type = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [position_fix_type]
    data.position_fix_type = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [heading_fix_type]
    data.heading_fix_type = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [num_connected_sats]
    data.num_connected_sats = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [num_sats_solution]
    data.num_sats_solution = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [cn0]
    data.cn0 = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [correction_age]
    data.correction_age = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 4 * object.cn0.length;
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_localization_msgs/GNSSStatus';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3fde27dc2ceba2593ee0c1c4446aa2cb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition containing the GNSS receiver status information.
    
    uint8 POSITION_RECEIVER = 0
    uint8 HEADING_RECEIVER = 1
    uint8 BASE_STATION_RECEIVER = 2
    uint8 receiver_type
    
    uint8 POSITION_NO_FIX = 0
    uint8 POSITION_SPP = 1
    uint8 POSITION_SBAS = 2
    uint8 POSITION_RTK_FLOAT = 3
    uint8 POSITION_RTK_FIXED = 4
    uint8 position_fix_type
    
    uint8 HEADING_NOT_APPLICABLE = 0
    uint8 HEADING_NO_SOLUTION = 1
    uint8 HEADING_RTK_FLOAT = 2
    uint8 HEADING_RTK_FIXED = 3
    uint8 heading_fix_type
    
    uint8 num_connected_sats	# Number of satellites connected to the antenna/receiver
    uint8 num_sats_solution   # Number of sats used in solution
    float32[] cn0			        # The carrier-to-noise ratio of each connected satellite
    float64 correction_age    # Age of RTK corrections. -1 indicates none received
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GNSSStatus(null);
    if (msg.receiver_type !== undefined) {
      resolved.receiver_type = msg.receiver_type;
    }
    else {
      resolved.receiver_type = 0
    }

    if (msg.position_fix_type !== undefined) {
      resolved.position_fix_type = msg.position_fix_type;
    }
    else {
      resolved.position_fix_type = 0
    }

    if (msg.heading_fix_type !== undefined) {
      resolved.heading_fix_type = msg.heading_fix_type;
    }
    else {
      resolved.heading_fix_type = 0
    }

    if (msg.num_connected_sats !== undefined) {
      resolved.num_connected_sats = msg.num_connected_sats;
    }
    else {
      resolved.num_connected_sats = 0
    }

    if (msg.num_sats_solution !== undefined) {
      resolved.num_sats_solution = msg.num_sats_solution;
    }
    else {
      resolved.num_sats_solution = 0
    }

    if (msg.cn0 !== undefined) {
      resolved.cn0 = msg.cn0;
    }
    else {
      resolved.cn0 = []
    }

    if (msg.correction_age !== undefined) {
      resolved.correction_age = msg.correction_age;
    }
    else {
      resolved.correction_age = 0.0
    }

    return resolved;
    }
};

// Constants for message
GNSSStatus.Constants = {
  POSITION_RECEIVER: 0,
  HEADING_RECEIVER: 1,
  BASE_STATION_RECEIVER: 2,
  POSITION_NO_FIX: 0,
  POSITION_SPP: 1,
  POSITION_SBAS: 2,
  POSITION_RTK_FLOAT: 3,
  POSITION_RTK_FIXED: 4,
  HEADING_NOT_APPLICABLE: 0,
  HEADING_NO_SOLUTION: 1,
  HEADING_RTK_FLOAT: 2,
  HEADING_RTK_FIXED: 3,
}

module.exports = GNSSStatus;
