// Auto-generated. Do not edit!

// (in-package clearpath_localization_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let GNSSStatus = require('./GNSSStatus.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class LocalizationStatus {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.accuracy = null;
      this.position_gnss = null;
      this.heading_gnss = null;
      this.base_station_gnss = null;
      this.dead_reckoning = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('accuracy')) {
        this.accuracy = initObj.accuracy
      }
      else {
        this.accuracy = 0.0;
      }
      if (initObj.hasOwnProperty('position_gnss')) {
        this.position_gnss = initObj.position_gnss
      }
      else {
        this.position_gnss = new GNSSStatus();
      }
      if (initObj.hasOwnProperty('heading_gnss')) {
        this.heading_gnss = initObj.heading_gnss
      }
      else {
        this.heading_gnss = new GNSSStatus();
      }
      if (initObj.hasOwnProperty('base_station_gnss')) {
        this.base_station_gnss = initObj.base_station_gnss
      }
      else {
        this.base_station_gnss = new GNSSStatus();
      }
      if (initObj.hasOwnProperty('dead_reckoning')) {
        this.dead_reckoning = initObj.dead_reckoning
      }
      else {
        this.dead_reckoning = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LocalizationStatus
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [accuracy]
    bufferOffset = _serializer.float32(obj.accuracy, buffer, bufferOffset);
    // Serialize message field [position_gnss]
    bufferOffset = GNSSStatus.serialize(obj.position_gnss, buffer, bufferOffset);
    // Serialize message field [heading_gnss]
    bufferOffset = GNSSStatus.serialize(obj.heading_gnss, buffer, bufferOffset);
    // Serialize message field [base_station_gnss]
    bufferOffset = GNSSStatus.serialize(obj.base_station_gnss, buffer, bufferOffset);
    // Serialize message field [dead_reckoning]
    bufferOffset = _serializer.bool(obj.dead_reckoning, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LocalizationStatus
    let len;
    let data = new LocalizationStatus(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [accuracy]
    data.accuracy = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [position_gnss]
    data.position_gnss = GNSSStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [heading_gnss]
    data.heading_gnss = GNSSStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [base_station_gnss]
    data.base_station_gnss = GNSSStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [dead_reckoning]
    data.dead_reckoning = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += GNSSStatus.getMessageSize(object.position_gnss);
    length += GNSSStatus.getMessageSize(object.heading_gnss);
    length += GNSSStatus.getMessageSize(object.base_station_gnss);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_localization_msgs/LocalizationStatus';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '166e5ca90227080fd9ba0eedbef721ee';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # # Message definition containing localization status information for all sources of localization
    
    std_msgs/Header header
    # the localization accuracy as a percentage value (covariance?)
    float32 accuracy # in development
    
    # status information related to the GPS receiver units
    GNSSStatus position_gnss
    GNSSStatus heading_gnss
    GNSSStatus base_station_gnss
    
    bool dead_reckoning
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_localization_msgs/GNSSStatus
    # Message definition containing the GNSS receiver status information.
    
    uint8 POSITION_RECEIVER = 0
    uint8 HEADING_RECEIVER = 1
    uint8 BASE_STATION_RECEIVER = 2
    uint8 receiver_type
    
    uint8 POSITION_NO_FIX = 0
    uint8 POSITION_SPP = 1
    uint8 POSITION_SBAS = 2
    uint8 POSITION_RTK_FLOAT = 3
    uint8 POSITION_RTK_FIXED = 4
    uint8 position_fix_type
    
    uint8 HEADING_NOT_APPLICABLE = 0
    uint8 HEADING_NO_SOLUTION = 1
    uint8 HEADING_RTK_FLOAT = 2
    uint8 HEADING_RTK_FIXED = 3
    uint8 heading_fix_type
    
    uint8 num_connected_sats	# Number of satellites connected to the antenna/receiver
    uint8 num_sats_solution   # Number of sats used in solution
    float32[] cn0			        # The carrier-to-noise ratio of each connected satellite
    float64 correction_age    # Age of RTK corrections. -1 indicates none received
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LocalizationStatus(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.accuracy !== undefined) {
      resolved.accuracy = msg.accuracy;
    }
    else {
      resolved.accuracy = 0.0
    }

    if (msg.position_gnss !== undefined) {
      resolved.position_gnss = GNSSStatus.Resolve(msg.position_gnss)
    }
    else {
      resolved.position_gnss = new GNSSStatus()
    }

    if (msg.heading_gnss !== undefined) {
      resolved.heading_gnss = GNSSStatus.Resolve(msg.heading_gnss)
    }
    else {
      resolved.heading_gnss = new GNSSStatus()
    }

    if (msg.base_station_gnss !== undefined) {
      resolved.base_station_gnss = GNSSStatus.Resolve(msg.base_station_gnss)
    }
    else {
      resolved.base_station_gnss = new GNSSStatus()
    }

    if (msg.dead_reckoning !== undefined) {
      resolved.dead_reckoning = msg.dead_reckoning;
    }
    else {
      resolved.dead_reckoning = false
    }

    return resolved;
    }
};

module.exports = LocalizationStatus;
